<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfString9 ArrayType
 * @subpackage Arrays
 */
class ArrayOfString9 extends AbstractStructArrayBase
{
    /**
     * The DestinationZone
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $DestinationZone;
    /**
     * Constructor method for ArrayOfString9
     * @uses ArrayOfString9::setDestinationZone()
     * @param string[] $destinationZone
     */
    public function __construct(array $destinationZone = array())
    {
        $this
            ->setDestinationZone($destinationZone);
    }
    /**
     * Get DestinationZone value
     * @return string[]|null
     */
    public function getDestinationZone()
    {
        return $this->DestinationZone;
    }
    /**
     * This method is responsible for validating the values passed to the setDestinationZone method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDestinationZone method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDestinationZoneForArrayConstraintsFromSetDestinationZone(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfString9DestinationZoneItem) {
            // validation for constraint: itemType
            if (!is_string($arrayOfString9DestinationZoneItem)) {
                $invalidValues[] = is_object($arrayOfString9DestinationZoneItem) ? get_class($arrayOfString9DestinationZoneItem) : sprintf('%s(%s)', gettype($arrayOfString9DestinationZoneItem), var_export($arrayOfString9DestinationZoneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DestinationZone property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DestinationZone value
     * @throws \InvalidArgumentException
     * @param string[] $destinationZone
     * @return \ArrayType\ArrayOfString9
     */
    public function setDestinationZone(array $destinationZone = array())
    {
        // validation for constraint: array
        if ('' !== ($destinationZoneArrayErrorMessage = self::validateDestinationZoneForArrayConstraintsFromSetDestinationZone($destinationZone))) {
            throw new \InvalidArgumentException($destinationZoneArrayErrorMessage, __LINE__);
        }
        $this->DestinationZone = $destinationZone;
        return $this;
    }
    /**
     * Add item to DestinationZone value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfString9
     */
    public function addToDestinationZone($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The DestinationZone property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DestinationZone[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DestinationZone
     */
    public function getAttributeName()
    {
        return 'DestinationZone';
    }
}
